"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const Settings_1 = __importDefault(require("./Settings"));
class Loader {
    constructor(options) {
        this._options = {};
        this._components = [];
        this._options = options;
        this._settings = new Settings_1.default();
    }
    load(components) {
        return __awaiter(this, void 0, void 0, function* () {
            this._components = components;
            yield this.loadComponents();
            return this._settings;
        });
    }
    loadComponents() {
        return __awaiter(this, void 0, void 0, function* () {
            for (const component of this._components) {
                yield component.load(this._settings);
            }
        });
    }
}
exports.default = Loader;
//# sourceMappingURL=Loader.js.map